/// <reference types="./default-connection-provider.d.ts" />
export class DefaultConnectionProvider {
    #driver;
    constructor(driver) {
        this.#driver = driver;
    }
    async withConnection(runner) {
        const connection = await this.#driver.acquireConnection();
        try {
            return await runner(connection);
        }
        finally {
            await this.#driver.releaseConnection(connection);
        }
    }
}
